local BeastCleaveSpellId = 118455;

local function SetDefaultPosistion(self)
	self:ClearAllPoints();
	self:SetPoint("LEFT",PlayerFrame,"RIGHT");
end

local function SetFrameSize(self, size)
	self:SetSize(size, size);
	_G[BCTOptions.size:GetName().."Text"]:SetText(size);
end

local BCTFrame = CreateFrame("Frame","BeastCleaveTracker",UIParent);
BCTFrame:Hide();
BCTFrame:SetMovable(true);
SetDefaultPosistion(BCTFrame);
BCTFrame:EnableMouse(false);
BCTFrame:RegisterForDrag("LeftButton");
BCTFrame:SetScript("OnDragStart", function(self) self:StartMoving(); end);
BCTFrame:SetScript("OnDragStop", function(self)	self:StopMovingOrSizing(); end);

BCTFrame.texture = BCTFrame:CreateTexture("BCTTexture","ARTWORK");
BCTFrame.texture:SetAllPoints(BCTFrame);
BCTFrame.texture:SetTexture("Interface\\Icons\\ability_hunter_sickem");

BCTFrame.cooldown = CreateFrame("Cooldown", "BCTCooldown", BCTFrame, "CooldownFrameTemplate");
BCTFrame.cooldown:SetAllPoints(BCTFrame);
BCTFrame.cooldown:SetDrawBling(false);
BCTFrame.cooldown:SetDrawSwipe(true);
BCTFrame.cooldown:SetDrawEdge(true);

local function onevent(self, event, ...)
	if(event == "ADDON_LOADED") then
		BCTFrame:UnregisterEvent("ADDON_LOADED");
		if(SBCTSaves == nil) then
			SBCTSaves = {};
			SBCTSaves.size = 30;
		end
		SetFrameSize(BCTFrame, SBCTSaves.size);
		BCTOptions.size:SetValue(SBCTSaves.size);
	elseif(event == "COMBAT_LOG_EVENT_UNFILTERED") then
		local _,e,_,sid,_,_,_,did,_,_,_ = ...;
		if(e == "SPELL_AURA_APPLIED" or e == "SPELL_AURA_REFRESH") then
			local spellId = select(12, ...);
			if(did == UnitGUID("pet") and spellId == BeastCleaveSpellId) then
				BCTFrame:Show();
				BCTFrame.cooldown:SetCooldown(GetTime(), 4);
			end
		elseif(e == "SPELL_AURA_REMOVED") then
			local spellId = select(12, ...);
			if(did == UnitGUID("pet") and spellId == BeastCleaveSpellId) then
				BCTFrame:Hide();
			end
		end
	end
end

local BCTOptions = CreateFrame("Frame","BCTOptions",UIParent);
BCTOptions.name = "Beast Cleave Tracker";
InterfaceOptions_AddCategory(BCTOptions);

BCTOptions.title = BCTOptions:CreateFontString();
BCTOptions.title:SetFontObject("GameFontNormalLarge");
BCTOptions.title:SetText("Simple Beast Cleave Tracker");
BCTOptions.title:SetPoint("TOPLEFT",BCTOptions, "TOPLEFT", 16, -16);

BCTOptions.move = CreateFrame("CheckButton", "BCTOptionsMove", BCTOptions, "UICheckButtonTemplate");
BCTOptions.move:SetPoint("TOPLEFT",BCTOptions.title, "BOTTOMLEFT");
_G[BCTOptions.move:GetName() .. "Text"]:SetText("Unlock frame for moving");
BCTOptions.move:SetScript("OnClick", function(self)
	if(self:GetChecked()) then
		BCTFrame:Show();
		BCTFrame:EnableMouse(true);
	else
		BCTFrame:EnableMouse(false);
		BCTFrame:Hide();
	end
end);

BCTOptions.moveReset = CreateFrame("Button", "BCTOptionsMoveReset", BCTOptions, "UIPanelButtonTemplate");
BCTOptions.moveReset:SetPoint("TOPLEFT",BCTOptions.move, "BOTTOMLEFT");
BCTOptions.moveReset:SetText("Reset to player frame");
BCTOptions.moveReset:SetWidth(200);
BCTOptions.moveReset:SetScript("OnClick", function() SetDefaultPosistion(BCTFrame); end);

BCTOptions.sizeText = BCTOptions:CreateFontString();
BCTOptions.sizeText:SetFontObject("GameFontNormal");
BCTOptions.sizeText:SetText("Size (default: 30)");
BCTOptions.sizeText:SetPoint("TOPLEFT", BCTOptions.moveReset, "BOTTOMLEFT", 0, -16);

BCTOptions.size = CreateFrame('Slider', 'BCTOptionsSize', BCTOptions, 'OptionsSliderTemplate');
BCTOptions.size:SetPoint("TOPLEFT",BCTOptions.sizeText, "BOTTOMLEFT", 0, -16);
BCTOptions.size:SetWidth(200);
BCTOptions.size:SetMinMaxValues(4, 80);
BCTOptions.size:SetValueStep(2);
BCTOptions.size:SetObeyStepOnDrag(true); 
_G[BCTOptions.size:GetName().."High"]:SetText(80);
_G[BCTOptions.size:GetName().."Low"]:SetText(4);
BCTOptions.size:SetScript("OnValueChanged", function(self, value) SBCTSaves.size = value; SetFrameSize(BCTFrame, SBCTSaves.size); end);

BCTFrame:RegisterEvent("ADDON_LOADED");
BCTFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED");
BCTFrame:SetScript("OnEvent", onevent);
